searchData={"items":[{"type":"module","doc":"A toolkit for fuzzy logic, this library includes functions for creating fuzzy variables, sets, rules and a FLS.","title":"Flex","ref":"Flex.html"},{"type":"behaviour","doc":"","title":"Flex.EngineAdapter","ref":"Flex.EngineAdapter.html"},{"type":"type","doc":"","title":"Flex.EngineAdapter.antecedent/0","ref":"Flex.EngineAdapter.html#t:antecedent/0"},{"type":"type","doc":"","title":"Flex.EngineAdapter.consequent/0","ref":"Flex.EngineAdapter.html#t:consequent/0"},{"type":"function","doc":"","title":"Flex.EngineAdapter.default_fuzzification/3","ref":"Flex.EngineAdapter.html#default_fuzzification/3"},{"type":"function","doc":"","title":"Flex.EngineAdapter.defuzzification/1","ref":"Flex.EngineAdapter.html#defuzzification/1"},{"type":"callback","doc":"","title":"Flex.EngineAdapter.defuzzification/1","ref":"Flex.EngineAdapter.html#c:defuzzification/1"},{"type":"type","doc":"Engine Adapter State.\n- `:type` - defines the inference engine behavior (default: Mamdini).\n- `:fuzzy_antecedent` - fuzzification output.\n- `:fuzzy_consequent` - inference output.\n- `:crisp_output` - defuzzification output.","title":"Flex.EngineAdapter.engine_state/0","ref":"Flex.EngineAdapter.html#t:engine_state/0"},{"type":"function","doc":"","title":"Flex.EngineAdapter.fuzzification/2","ref":"Flex.EngineAdapter.html#fuzzification/2"},{"type":"callback","doc":"","title":"Flex.EngineAdapter.fuzzification/2","ref":"Flex.EngineAdapter.html#c:fuzzification/2"},{"type":"function","doc":"","title":"Flex.EngineAdapter.get_crisp_output/1","ref":"Flex.EngineAdapter.html#get_crisp_output/1"},{"type":"function","doc":"","title":"Flex.EngineAdapter.inference/3","ref":"Flex.EngineAdapter.html#inference/3"},{"type":"callback","doc":"","title":"Flex.EngineAdapter.inference/3","ref":"Flex.EngineAdapter.html#c:inference/3"},{"type":"type","doc":"","title":"Flex.EngineAdapter.rules/0","ref":"Flex.EngineAdapter.html#t:rules/0"},{"type":"function","doc":"","title":"Flex.EngineAdapter.validation/4","ref":"Flex.EngineAdapter.html#validation/4"},{"type":"callback","doc":"","title":"Flex.EngineAdapter.validation/4","ref":"Flex.EngineAdapter.html#c:validation/4"},{"type":"module","doc":"An adaptive network-based fuzzy inference system (ANFIS) is a kind of artificial neural network that is based on Takagi–Sugeno fuzzy inference system,\nthis implementation use backpropagation, only Gaussian Membership function are allowed.\nReference:\nhttps://upcommons.upc.edu/bitstream/handle/2099.1/20296/Annex%201%20-%20Introduction%20to%20Adaptive%20Neuro-Fuzzy%20Inference%20Systems%20%28ANFIS%29.pdf\nJang, J-SR. \"ANFIS: adaptive-network-based fuzzy inference system.\" IEEE transactions on systems, man, and cybernetics 23.3 (1993): 665-685.","title":"Flex.EngineAdapter.ANFIS","ref":"Flex.EngineAdapter.ANFIS.html"},{"type":"function","doc":"","title":"Flex.EngineAdapter.ANFIS.backward_pass/3","ref":"Flex.EngineAdapter.ANFIS.html#backward_pass/3"},{"type":"function","doc":"","title":"Flex.EngineAdapter.ANFIS.forward_pass/3","ref":"Flex.EngineAdapter.ANFIS.html#forward_pass/3"},{"type":"function","doc":"","title":"Flex.EngineAdapter.ANFIS.inference_engine/3","ref":"Flex.EngineAdapter.ANFIS.html#inference_engine/3"},{"type":"function","doc":"","title":"Flex.EngineAdapter.ANFIS.least_square_estimate/4","ref":"Flex.EngineAdapter.ANFIS.html#least_square_estimate/4"},{"type":"function","doc":"","title":"Flex.EngineAdapter.ANFIS.weighted_average_method/1","ref":"Flex.EngineAdapter.ANFIS.html#weighted_average_method/1"},{"type":"module","doc":"Mamdani fuzzy inference was first introduced as a method to create a control system by synthesizing a set of linguistic control rules obtained from experienced human operators.\nIn a Mamdani system, the output of each rule is a fuzzy set. Since Mamdani systems have more intuitive and easier to understand rule bases,\nthey are well-suited to expert system applications where the rules are created from human expert knowledge, such as medical diagnostics.","title":"Flex.EngineAdapter.Mamdani","ref":"Flex.EngineAdapter.Mamdani.html"},{"type":"function","doc":"Turns an consequent fuzzy variable (output) from a fuzzy value to a crisp value (centroid method).","title":"Flex.EngineAdapter.Mamdani.centroid_method/1","ref":"Flex.EngineAdapter.Mamdani.html#centroid_method/1"},{"type":"function","doc":"","title":"Flex.EngineAdapter.Mamdani.inference_engine/3","ref":"Flex.EngineAdapter.Mamdani.html#inference_engine/3"},{"type":"module","doc":"Takagi-Sugeno-Kang fuzzy inference uses singleton output membership functions that are either constant or a linear function of the input values.\nThe defuzzification process for a Sugeno system is more computationally efficient compared to that of a Mamdani system,\nsince it uses a weighted average or weighted sum of a few data points rather than compute a centroid of a two-dimensional area.","title":"Flex.EngineAdapter.TakagiSugeno","ref":"Flex.EngineAdapter.TakagiSugeno.html"},{"type":"function","doc":"","title":"Flex.EngineAdapter.TakagiSugeno.inference_engine/3","ref":"Flex.EngineAdapter.TakagiSugeno.html#inference_engine/3"},{"type":"function","doc":"Turns an consequent fuzzy variable (output) from a fuzzy value to a crisp value (weighted average method).","title":"Flex.EngineAdapter.TakagiSugeno.weighted_average_method/1","ref":"Flex.EngineAdapter.TakagiSugeno.html#weighted_average_method/1"},{"type":"module","doc":"An interface to create Membership Functions reference.","title":"Flex.MembershipFun","ref":"Flex.MembershipFun.html"},{"type":"function","doc":"Gaussian membership derivatived function.\n  * `m` - (number) Mean,\n  * `s` - (number) Standard deviation, it must not be equal to 0.\n  * `f` - (number) Fuzzification Factor.\n  * `mu` - (number) Last membership function value.","title":"Flex.MembershipFun.d_gaussian/4","ref":"Flex.MembershipFun.html#d_gaussian/4"},{"type":"function","doc":"Generalized Bell membership  derivatived function.\n  * `c` - (number) Center.\n  * `s` - (number) Slope.\n  * `b` - (number) The width of the curve, it must not be equal to 0.\n\nDefinition of Generalized Bell function is:\n      y(x) = 1 / (1 + |((x - c) / b)|^(2 * s))","title":"Flex.MembershipFun.d_gbell/4","ref":"Flex.MembershipFun.html#d_gbell/4"},{"type":"function","doc":"An interface to execute derivatives of membership functions, where,\n  * `z_i` - is the i'th rule output.\n  * `x, y` - are the values of input 1 and input 2, respectively.\n  * `a_i, b_i, and c_i` - are constant coefficients of the i'th rule output.\n  For a zero-order Takagi-Sugeno system, z_i is a constant (a = b = 0).","title":"Flex.MembershipFun.derivative/4","ref":"Flex.MembershipFun.html#derivative/4"},{"type":"function","doc":"Gaussian membership function.\n  * `m` - (number) Mean,\n  * `s` - (number) Standard deviation, it must not be equal to 0.\n  * `f` - (number) Fuzzification Factor,","title":"Flex.MembershipFun.gaussian/1","ref":"Flex.MembershipFun.html#gaussian/1"},{"type":"function","doc":"Generalized Bell membership function.\n  * `c` - (number) Center.\n  * `s` - (number) Slope.\n  * `b` - (number) The width of the curve, it must not be equal to 0.\n\nDefinition of Generalized Bell function is:\n      y(x) = 1 / (1 + |((x - c) / b)|^(2 * s))","title":"Flex.MembershipFun.gbell/1","ref":"Flex.MembershipFun.html#gbell/1"},{"type":"function","doc":"For Takagi-Sugeno-Kang fuzzy inference, uses this output membership functions that are either constant\nor a linear function that will be combined with the input values.\n\nExample (2 inputs 1 output):\n  z_i = a_i*x + b_i*y + c_i\n\nwhere,\n  * `z_i` - is the i'th rule output.\n  * `x, y` - are the values of input 1 and input 2, respectively.\n  * `a_i, b_i, and c_i` - are constant coefficients of the i'th rule output.\n  For a zero-order Takagi-Sugeno system, z_i is a constant (a = b = 0).","title":"Flex.MembershipFun.linear_combination/1","ref":"Flex.MembershipFun.html#linear_combination/1"},{"type":"function","doc":"iex> {z_i_mf, nil} = MembershipFun.linear_combination([a_i, b_i, c_i])\n    iex> z_i = z_i_mf.([x,y])","title":"Example (in Elixir) - Flex.MembershipFun.linear_combination/1","ref":"Flex.MembershipFun.html#linear_combination/1-example-in-elixir"},{"type":"function","doc":"Pi-shaped membership function.","title":"Flex.MembershipFun.pi_shaped/1","ref":"Flex.MembershipFun.html#pi_shaped/1"},{"type":"function","doc":"S-shaped membership function.","title":"Flex.MembershipFun.s_shaped/1","ref":"Flex.MembershipFun.html#s_shaped/1"},{"type":"function","doc":"Saturation membership function.","title":"Flex.MembershipFun.saturation/1","ref":"Flex.MembershipFun.html#saturation/1"},{"type":"function","doc":"Shoulder membership function.","title":"Flex.MembershipFun.shoulder/1","ref":"Flex.MembershipFun.html#shoulder/1"},{"type":"function","doc":"Sigmoidal membership function.\n  * `c` - (number) Crossover point.\n  * `s` - (number) Slope.\n\nDefinition of Generalized Bell function is:\n      y(x) = 1 / (1 + e^(-s(x-c)))","title":"Flex.MembershipFun.sigmoid/1","ref":"Flex.MembershipFun.html#sigmoid/1"},{"type":"function","doc":"Trapezoidal membership function.","title":"Flex.MembershipFun.trapezoidal/1","ref":"Flex.MembershipFun.html#trapezoidal/1"},{"type":"function","doc":"Triangle membership function.","title":"Flex.MembershipFun.triangle/1","ref":"Flex.MembershipFun.html#triangle/1"},{"type":"function","doc":"Z-shaped membership function.","title":"Flex.MembershipFun.z_shaped/1","ref":"Flex.MembershipFun.html#z_shaped/1"},{"type":"module","doc":"An interface to create Linguistic Rules.","title":"Flex.Rule","ref":"Flex.Rule.html"},{"type":"function","doc":"Fuzzy AND operator.","title":"Flex.Rule.&&&/2","ref":"Flex.Rule.html#&&&/2"},{"type":"function","doc":"Fuzzy THEN operator.","title":"Flex.Rule.>>>/2","ref":"Flex.Rule.html#%3E%3E%3E/2"},{"type":"function","doc":"Gets the arguments of the Fuzzy Rule","title":"Flex.Rule.get_rule_parameters/3","ref":"Flex.Rule.html#get_rule_parameters/3"},{"type":"function","doc":"Creates a Linguistic Rule.\n\nThe following options are require:\n  - `:statement` - Defines the rule behavior.\n  - `:antecedent` - (list) Defines the input variables.\n  - `:consequent` - Defines the output variable.","title":"Flex.Rule.new/1","ref":"Flex.Rule.html#new/1"},{"type":"function","doc":"Fuzzy Rules AST (Tuple).","title":"Flex.Rule.statement/2","ref":"Flex.Rule.html#statement/2"},{"type":"type","doc":"Linguistic Rule struct.\n- `:statement` - Rules behavior.\n- `:antecedent` - (list) Input variables.\n- `:consequent` - Output variable.","title":"Flex.Rule.t/0","ref":"Flex.Rule.html#t:t/0"},{"type":"function","doc":"Fuzzy AND operator (product).","title":"Flex.Rule.tau/2","ref":"Flex.Rule.html#tau/2"},{"type":"function","doc":"Fuzzy OR operator.","title":"Flex.Rule.|||/2","ref":"Flex.Rule.html#%7C%7C%7C/2"},{"type":"function","doc":"Fuzzy IS operator.","title":"Flex.Rule.~>/2","ref":"Flex.Rule.html#~%3E/2"},{"type":"module","doc":"An interface to create Fuzzy Sets struct.","title":"Flex.Set","ref":"Flex.Set.html"},{"type":"function","doc":"Creates a Fuzzy set.\n\nThe following options are require:\n  * `:mf_type` - (string) Defines which type of membership function uses the set (e.g., \"triangle\").\n  * `:tag` - (string) defines the linguistic name of the fuzzy set (e.g., \"too hot\"),\n  * `:mf_params` - The parameters of the membership function, see Membership functions.","title":"Flex.Set.new/1","ref":"Flex.Set.html#new/1"},{"type":"type","doc":"Fuzzy Set struct.\n- `:mf_type` - Defines which type of membership function uses the set.\n- `:mf` - Anonymous function reference of the membership function.\n- `:mf_center` - The center point of the membership function.\n- `:mf_params` - The parameters of the membership function.\n- `:tag` - Linguistic name of the fuzzy set.","title":"Flex.Set.t/0","ref":"Flex.Set.html#t:t/0"},{"type":"function","doc":"Updates a Fuzzy set with new membership function parameters.","title":"Flex.Set.update/2","ref":"Flex.Set.html#update/2"},{"type":"function","doc":"Updates a Fuzzy set depending on the gradient.","title":"Flex.Set.update/3","ref":"Flex.Set.html#update/3"},{"type":"module","doc":"An interface to create a Fuzzy Logic Control System (FLS).\n\nThe Fuzzy controllers are very simple conceptually. They consist of an input stage (fuzzification), a processing stage (inference), and an output stage (defuzzification).","title":"Flex.System","ref":"Flex.System.html"},{"type":"function","doc":"Adjust the premise free parameters of the FIS (only avaliable with ANFIS engine), using the following methods:\n  - Learning method: Steepest gradient Backpropagation.\n  - Energy function: 0.5 * (target - output)^2","title":"Flex.System.backward_pass/2","ref":"Flex.System.html#backward_pass/2"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"Flex.System.child_spec/1","ref":"Flex.System.html#child_spec/1"},{"type":"function","doc":"Computes the Fuzzy Logic System output for a given input vector.","title":"Flex.System.compute/2","ref":"Flex.System.html#compute/2"},{"type":"function","doc":"Adjust the consequent free parameters of the FIS (only avaliable with ANFIS engine), using the following methods:\n  - Learning method: Steepest gradient Backpropagation.\n  - Energy function: 0.5 * (target - output)^2","title":"Flex.System.forward_pass/2","ref":"Flex.System.html#forward_pass/2"},{"type":"function","doc":"Gets the current system state.","title":"Flex.System.get_state/1","ref":"Flex.System.html#get_state/1"},{"type":"function","doc":"Adjust the free parameters of the FIS (only avaliable with ANFIS engine), using the following methods:\n  - Forward method: Least Square Estimate.\n  - Learning method: Steepest gradient Backpropagation.\n  - Energy function: 0.5 * (target - output)^2\nNote: this functions fires both forward and backward passes with a batch of data.","title":"Flex.System.hybrid_offline_learning/4","ref":"Flex.System.html#hybrid_offline_learning/4"},{"type":"function","doc":"Adjust the free parameters of the FIS (only avaliable with ANFIS engine), using the following methods:\n  - Learning method: Steepest gradient Backpropagation.\n  - Energy function: 0.5 * (target - output)^2\nNote: this functions fires both forward and backward passes.","title":"Flex.System.hybrid_online_learning/2","ref":"Flex.System.html#hybrid_online_learning/2"},{"type":"function","doc":"","title":"Flex.System.init/1","ref":"Flex.System.html#init/1"},{"type":"function","doc":"Sets the Inference Engine type.","title":"Flex.System.set_engine_type/2","ref":"Flex.System.html#set_engine_type/2"},{"type":"function","doc":"Sets the Learning rate (etha).","title":"Flex.System.set_learning_rate/2","ref":"Flex.System.html#set_learning_rate/2"},{"type":"function","doc":"Spawns a Fuzzy Logic System.\n\nThe following options are require:\n  - `:rules` - Defines the behavior of the system based on a list of rules.\n  - `:antecedent` - (list) Defines the input variables.\n  - `:consequent` - Defines the output variable.","title":"Flex.System.start_link/2","ref":"Flex.System.html#start_link/2"},{"type":"function","doc":"","title":"Flex.System.stop/1","ref":"Flex.System.html#stop/1"},{"type":"type","doc":"Fuzzy Logic System state.\n- `:rules` - (list) A list of rules that defines the behavior of the Fuzzy logic systems.\n- `:consequent` - Output variable.\n- `:antecedent` - a list of the input variables.\n- `:engine_type` - defines the inference engine behavior (default: Mamdini).\n- `:sets_in_rules` - list of sets involve in the rules (optional, required by ANFIS).\n- `:learning_rate` - is the speed at which the system parameters are adjusted (ANFIS only).\n- `:initial_gamma` - is the speed at which the system parameters are adjusted (LSE, ANFIS only).","title":"Flex.System.t/0","ref":"Flex.System.html#t:t/0"},{"type":"module","doc":"Module with helper functions.","title":"Flex.Util","ref":"Flex.Util.html"},{"type":"module","doc":"An interface to create Fuzzy Variables.","title":"Flex.Variable","ref":"Flex.Variable.html"},{"type":"function","doc":"Turns an antecedent fuzzy variable (input) from a crisp value to a fuzzy value.","title":"Flex.Variable.fuzzification/2","ref":"Flex.Variable.html#fuzzification/2"},{"type":"function","doc":"Creates a Fuzzy Variable.\n\nThe following options are require:\n  * `:tag` - (string) Defines the linguistic name of the fuzzy variable (e.g., \"error\"),\n  * `:fuzzy_sets` - (list) Defines which type of membership function use the set (e.g., \"triangle\").\n  * `:type` - (atom) Defines the type of variable (e.g., :antecedent or :consequent),\n  * `:range` - (range) The range in which the variable exists.","title":"Flex.Variable.new/1","ref":"Flex.Variable.html#new/1"},{"type":"type","doc":"Fuzzy Variable struct.\n- `:tag` - (string) Defines the linguistic name of the fuzzy variable (e.g., \"error\").\n- `:fuzzy_sets` - (list) Defines which all the fuzzy sets related to the variable.\n- `:mf_values` - (map) The current values of each of the membership functions of the fuzzy sets.\n- `:range` - (range) The range in which the variable exists.\n- `:type` - (atom) :antecedent if the variable is an input or consequent for outputs.","title":"Flex.Variable.t/0","ref":"Flex.Variable.html#t:t/0"},{"type":"function","doc":"Updates a consequent Fuzzy Variable (ANFIS).","title":"Flex.Variable.update/2","ref":"Flex.Variable.html#update/2"},{"type":"function","doc":"Updates an antecedent Fuzzy Variable (ANFIS).","title":"Flex.Variable.update/3","ref":"Flex.Variable.html#update/3"},{"type":"extras","doc":"***\n \n \n   \n \n \n\n\n# FLex\n\nA toolkit for fuzzy logic, this library includes functions to make fuzzy sets, variables and rules for creating a Fuzzy Logic System (FLS).\n\nThe goal of FLex is to easily design and efficiently operate fuzzy logic controllers without relying on external libraries.","title":"README","ref":"readme.html"},{"type":"extras","doc":"* [Features](#features)\n\n* [Installation](#installation)\n\n* [Usage](#usage)\n    * [Sets](#sets)\n    * [Variables](#variables)\n    * [Rules](#rules)\n    * [System](#system)\n    * [ANFIS](#anfis)\n\n* [Documentation](#documentation)\n\n* [Contributing](#contributing)\n\n* [License](#License)\n\n* [TODO](#todo)","title":"Index - README","ref":"readme.html#index"},{"type":"extras","doc":"The following list is the current supported backend for each component of the FLS:\n\n- Linguistic Rules:\n  - Lambda function syntax\n  - Tuple syntax\n\n- Membership functions:\n  - Triangular\n  - Trapezoidal\n  - Saturation\n  - Shoulder\n  - Gauss\n  - Generalized Bell\n  - Sigmoid\n  - Z-shaped\n  - S-shaped\n  - Pi-shaped\n  - Linear Combination (Takagi-Sugeno, ANFIS only)\n\n- Fuzzy Inference Systems:\n  - Mamdani:\n    - Inference:\n      - Min\n\n    - Output Combination:\n      - Root-sum-square\n\n    - Defuzzification:\n      - Centroid\n\n  - Takagi-Sugeno:\n    - Inference:  \n      - Max\n      - Product\n      \n    - Defuzzification:\n      - Weighted average\n\n  - ANFIS:\n    - Inference:  \n      - Max\n      - Product\n      \n    - Defuzzification:\n      - Weighted average\n\n    - Optimization Method:\n      - Backpropagation.\n      - Hybrid (Backpropagation, LSE).\n\n\n**NOTE:** All systems are single output.","title":"Features - README","ref":"readme.html#features"},{"type":"extras","doc":"The package can be installed by adding `flex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:flex, \"~> 0.1.0\"}\n  ]\nend\n```","title":"Installation - README","ref":"readme.html#installation"},{"type":"extras","doc":"***","title":"Usage - README","ref":"readme.html#usage"},{"type":"extras","doc":"**Step 1:** Define all fuzzy sets with `Flex.Set.new/1`, the following options are require:\n  - `mf_type` - (string) Defines which type of membership function uses the set (e.g., \"triangle\").\n  - `tag` - (string) defines the linguistic name of the fuzzy set (e.g., \"too hot\"),\n  - `mf_params` - The parameters of the membership function, see Membership functions.\n\n```elixir\nt_h = Flex.Set.new(tag: \"too hot\", mf_type: \"saturation\", mf_params: [-2, 0, -4])\nj_r = Flex.Set.new(tag: \"just right\", mf_type: \"triangle\", mf_params: [-2, 0, 2])\nt_c = Flex.Set.new(tag: \"too cold\", mf_type: \"shoulder\", mf_params: [0, 2, 4])\n\ng_h = Flex.Set.new(tag: \"getting hotter\", mf_type: \"saturation\", mf_params: [-5, 0, -10])\nn_c = Flex.Set.new(tag: \"no change\", mf_type: \"triangle\", mf_params: [-5, 0, 5])\ng_c = Flex.Set.new(tag: \"getting colder\", mf_type: \"shoulder\", mf_params: [0, 5, 10])\n\nco = Flex.Set.new(tag: \"cool\", mf_type: \"saturation\", mf_params: [-50, 0, -100])\nd_n = Flex.Set.new(tag: \"do nothing\", mf_type: \"triangle\", mf_params: [-50, 0, 50])\nhe = Flex.Set.new(tag: \"heat\", mf_type: \"shoulder\", mf_params: [0, 50, 100])\n```","title":"Sets - README","ref":"readme.html#sets"},{"type":"extras","doc":"**Step 2:** Define all fuzzy variables with `Flex.Variable.new/1`, the following options are required:\n  * `:tag` - (string) Defines the linguistic name of the fuzzy variable (e.g., \"error\"),\n  * `:fuzzy_sets` - (list) Defines which type of membership function use the set (e.g., \"triangle\").\n  * `:type` - (atom) Defines the type of variable (e.g., :antecedent or :consequent),\n  * `:range` - (range) The range in which the variable exists.\n\n```elixir\nfuzzy_sets = [t_h, j_r, t_c]\nerror = Flex.Variable.new(tag: \"error\", fuzzy_sets: fuzzy_sets, type: :antecedent, range: -4..4)\n\nfuzzy_sets = [g_h, n_c, g_c]\ndt_error = Flex.Variable.new(tag: \"dt_error\", fuzzy_sets: fuzzy_sets, type: :antecedent, range: -10..10)\n\nfuzzy_sets = [co, d_n, he]\noutput = Flex.Variable.new(tag: \"output\", fuzzy_sets: fuzzy_sets, type: :consequent, range: -100..100)\n```","title":"Variables - README","ref":"readme.html#variables"},{"type":"extras","doc":"Currently there are two types of syntax for defining the rules `statement`:\n  * Anonymous function syntax:\n```elixir\n  r1 = fn [at1, at2, con] ->\n      (at1 ~> \"too hot\" &&& at2 ~> \"getting colder\") >>> con ~> \"cool\"\n    end\n```\n  * Tuple syntax:\n```elixir\n  r1 = {{{{\"error\", \"too hot\", \"~>\"}, {\"dt_error\", \"getting colder\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"cool\", \"~>\"}\n```\n**Step 3:** Define all Linguistic rules with `Flex.Rule.new/1`, the following options are required:\n  - `:statement` - Defines the rule behavior.\n  - `:antecedent` - (list) Defines the input variables.\n  - `:consequent` - Defines the output variable.\n\n```elixir\n  import Flex.Rule\n  r1 =\n    {{{{\"error\", \"too hot\", \"~>\"}, {\"dt_error\", \"getting colder\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"cool\", \"~>\"}\n\n  r2 =\n    {{{{\"error\", \"just right\", \"~>\"}, {\"dt_error\", \"getting colder\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"heat\", \"~>\"}\n\n  r3 =\n    {{{{\"error\", \"too cold\", \"~>\"}, {\"dt_error\", \"getting colder\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"heat\", \"~>\"}\n\n  r4 =\n    {{{{\"error\", \"too hot\", \"~>\"}, {\"dt_error\", \"no change\", \"~>\"}, \"&&&\"}, \"output\", \">>>\"},\n      \"cool\", \"~>\"}\n\n  r5 =\n    {{{{\"error\", \"just right\", \"~>\"}, {\"dt_error\", \"no change\", \"~>\"}, \"&&&\"}, \"output\", \">>>\"},\n      \"do nothing\", \"~>\"}\n\n  r6 =\n    {{{{\"error\", \"too cold\", \"~>\"}, {\"dt_error\", \"no change\", \"~>\"}, \"&&&\"}, \"output\", \">>>\"},\n      \"heat\", \"~>\"}\n\n  r7 =\n    {{{{\"error\", \"too hot\", \"~>\"}, {\"dt_error\", \"getting hotter\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"cool\", \"~>\"}\n\n  r8 =\n    {{{{\"error\", \"just right\", \"~>\"}, {\"dt_error\", \"getting hotter\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"cool\", \"~>\"}\n\n  r9 =\n    {{{{\"error\", \"too cold\", \"~>\"}, {\"dt_error\", \"getting hotter\", \"~>\"}, \"&&&\"}, \"output\",\n      \">>>\"}, \"cool\", \"~>\"}\n\n  rule1 = Flex.Rule.new(statement: r1, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule2 = Flex.Rule.new(statement: r2, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule3 = Flex.Rule.new(statement: r3, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule4 = Flex.Rule.new(statement: r4, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule5 = Flex.Rule.new(statement: r5, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule6 = Flex.Rule.new(statement: r6, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule7 = Flex.Rule.new(statement: r7, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule8 = Flex.Rule.new(statement: r8, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n  rule9 = Flex.Rule.new(statement: r9, consequent: output.tag, antecedent: [error.tag, dt_error.tag])\n\n  rules = [rule1, rule2, rule3, rule4, rule5, rule6, rule7, rule8, rule9]\n\n```\n**Note**: You need to `import Flex.Rule` module.","title":"Rules - README","ref":"readme.html#rules"},{"type":"extras","doc":"**Step 4:** Define FLS with `Flex.System.start_link/1` or `Flex.System.start_link/2` if you want to overwrite the GenServer options; the following options are require:\n  - `:rules` - Defines the behavior of the system based on a list of rules.\n  - `:antecedent` - (list) Defines the input variables.\n  - `:consequent` - Defines the output variable.\n  - `:engine_type` - Defines the inference engine behavior (default: Mamdini).\n\n```elixir\n  {:ok, s_pid} = Flex.System.start_link(antecedent: [error, dt_error], consequent: output, rules: rules)\n```\n\n**Step 5:** Fit the FLS with a input vector using `Flex.System.compute/2`.\n```elixir\n  result = Flex.System.compute(s_pid, [-1, -2.5])\n  #result ~= -63.4 aprox\n```\n\nIn `test/system_test.exs` there is an example of use, that is based on this [example](http://robotics.ee.uwa.edu.au/courses/faulttolerant/notes/FT5.pdf).","title":"System - README","ref":"readme.html#system"},{"type":"extras","doc":"An adaptive network-based fuzzy inference system (ANFIS) is a kind of artificial neural network that is based on Takagi–Sugeno fuzzy inference system, this implementation use backpropagation, only Gaussian & Generalized Bell Membership functions are allowed. In `examples/anfis_demo1.exs` there is an example of use.","title":"ANFIS - README","ref":"readme.html#anfis"},{"type":"extras","doc":"The docs can be found at [https://hexdocs.pm/flex](https://hexdocs.pm/flex).","title":"Documentation - README","ref":"readme.html#documentation"},{"type":"extras","doc":"* Fork our repository on github.\n  * Fix or add what is needed.\n  * Commit to your repository.\n  * Issue a github pull request (fill the PR template).","title":"Contributing - README","ref":"readme.html#contributing"},{"type":"extras","doc":"See [LICENSE](https://github.com/valiot/flex/blob/master/LICENSE).","title":"License - README","ref":"readme.html#license"},{"type":"extras","doc":"* Add more membership functions.\n  * Add more inference methods.\n  * Add more defuzzification methods.\n  * Add helper functions.\n  * Add metaprogramming for linguistic rules.","title":"TODO - README","ref":"readme.html#todo"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}